<template>
    <div class="plot-item-with-controls" v-if="plot_type == 'scatterplot' || plot_type == 'histogram'">
        <img :id="plot_id" :src="image_url">
        <!--Scatterplot-->
        <div class="plot-controls" v-if="plot_type == 'scatterplot'">
            <label for="sc_metabolite_1">Select metabolite to plot (<b>x</b>):</label>
            <select id="sc_metabolite_1" v-model="scatter_metabolite_1" @change="getNconcsForMetabolite(scatter_metabolite_1)">
                <option disabled selected value="default">Select..</option>
                <option v-for="metabolite of query.query_active_metabolites" :value="metabolite">{{ metabolite }}</option>
            </select>
            <label for="sc_metabolite_2">Select metabolite to plot (<b>y</b>):</label>
            <select id="sc_metabolite_2" v-model="scatter_metabolite_2"  @change="getNconcsForMetabolite(scatter_metabolite_2)">
                <option disabled selected value="default">Select..</option>
                <option v-for="metabolite of query.query_active_metabolites" :value="metabolite">{{ metabolite }}</option>
            </select>
            <label for="sc_phenotype" v-if="query.query_phenotypes && Object.keys(query.query_phenotypes).length > 0">Select phenotype to plot:</label>
            <select id="sc_phenotype" v-if="query.query_phenotypes && Object.keys(query.query_phenotypes).length > 0" v-model="scatter_phenotype">
                <option selected value="default">None</option>
                <option v-for="phenotype of applicable_phenotypes" :value="phenotype">{{ phenotype }}</option>
            </select>
            <label for="sc_vis1" v-if="scatter_metabolite_1 != 'default'">Highlight range for <b>{{ scatter_metabolite_1 }}</b>:</label>
            <select id="sc_vis1" v-if="scatter_metabolite_1 != 'default'" v-model="scatter_vis_string_1">
                <option selected value="vis"
                v-if="query.query_filters?.filter((f) => f.filter_type == 'vis').map((f) => f.compound_id).includes(scatter_metabolite_1)">
                    <b>Use query filter range</b>
                </option>
                <option disabled selected value="default">None</option>
                <option value="custom">Custom range</option>
                <option v-for="nconc in nconcs[scatter_metabolite_1]" :value="nconc">{{ nconc.nconc_min }}-{{ nconc.nconc_max }} {{nconc.nconc_unit}}</option>
            </select>
            <label for="sc_vis1_custom" v-if="scatter_vis_string_1 == 'custom'">Set vis. range for <b>{{ scatter_metabolite_1 }}</b>:</label>
            <div id="sc_vis1_custom" v-if="scatter_vis_string_1 == 'custom'" class="range">
                <input type="text" v-model="scatter_vis1_custom_min">
                <input type="text" v-model="scatter_vis1_custom_max">
            </div>
            <label for="sc_vis2" v-if="scatter_metabolite_2 != 'default'">Highlight range for <b>{{ scatter_metabolite_2 }}</b>:</label>
            <select id="sc_vis2" v-if="scatter_metabolite_2 != 'default'" v-model="scatter_vis_string_2">
                <option selected value="vis"
                v-if="query.query_filters?.filter((f) => f.filter_type == 'vis').map((f) => f.compound_id).includes(scatter_metabolite_2)">
                    <b>Use query filter range</b>
                </option>
                <option disabled selected value="default">None</option>
                <option value="custom">Custom range</option>
                <option v-for="nconc in nconcs[scatter_metabolite_2]" :value="nconc">{{ nconc.nconc_min }}-{{ nconc.nconc_max }} {{nconc.nconc_unit}}</option>
            </select>
            <label for="sc_vis2_custom" v-if="scatter_vis_string_2 == 'custom'">Set vis. range for <b>{{ scatter_metabolite_2 }}</b>:</label>
            <div id="sc_vis2_custom" v-if="scatter_vis_string_2 == 'custom'" class="range">
                <input type="text" v-model="scatter_vis2_custom_min">
                <input type="text" v-model="scatter_vis2_custom_max">
            </div>
            <button style="align-self: center;" :disabled="scatter_metabolite_1 == 'default' ||scatter_metabolite_2 == 'default'"
            @click="newScatterplot">Submit</button>
        </div>
        <!--Histogram-->
        <div class="plot-controls" v-if="plot_type == 'histogram'">
            <label for="hs_metabolite">Select metabolite to plot:</label>
            <select id="hs_metabolite" v-model="hist_metabolite" @change="getNconcsForMetabolite(hist_metabolite)">
                <option disabled selected value="default">Select..</option>
                <option v-for="metabolite of query.query_active_metabolites" :value="metabolite">{{ metabolite }}</option>
            </select>
            <label for="hs_phenotype" v-if="query.query_phenotypes && Object.keys(query.query_phenotypes).length > 0">Select phenotype to plot:</label>
            <select id="hs_phenotype" v-if="query.query_phenotypes && Object.keys(query.query_phenotypes).length > 0" v-model="hist_phenotype">
                <option selected value="default">None</option>
                <option v-for="phenotype of applicable_phenotypes" :value="phenotype">{{ phenotype }}</option>
            </select>
            <label for="hs_vis" v-if="hist_metabolite != 'default'">Highlight range for <b>{{ hist_metabolite }}</b>:</label>
            <select id="hs_vis" v-if="hist_metabolite != 'default'" v-model="hist_vis_string">
                <option selected value="vis"
                v-if="query.query_filters?.filter((f) => f.filter_type == 'vis').map((f) => f.compound_id).includes(hist_metabolite)">
                    <b>Use query filter range</b>
                </option>
                <option disabled selected value="default">None</option>
                <option value="custom">Custom range</option>
                <option v-for="nconc in nconcs[hist_metabolite]" :value="nconc">{{ nconc.nconc_min }}-{{ nconc.nconc_max }} {{nconc.nconc_unit}}</option>
            </select>
            <label for="hist_vis_custom" v-if="hist_vis_string == 'custom'">Set vis. range for <b>{{ hist_metabolite }}</b>:</label>
            <div id="hist_vis_custom" v-if="hist_vis_string == 'custom'" class="range">
                <input type="text" v-model="hist_vis_custom_min">
                <input type="text" v-model="hist_vis_custom_max">
            </div>
            <label for="hs_style">Histogram Style:</label>
            <select id="hs_style" v-model="hist_style">
                <option selected value="step|fill">Step, filled</option>
                <option value="step|nofill">Step, not filled</option>
                <option value="bars|fill">Bars, filled</option>
                <option value="bars|nofill">Bars, not filled</option>
                <option value="poly|fill">Polygon, filled</option>
                <option value="poly|nofill">Polygon, not filled</option>
            </select>
            <label for="hs_bins">Bins:</label>
            <input type="number" style="margin-bottom: 1rem;" v-model="hist_bins">
            
            <button style="align-self: center;" :disabled="hist_metabolite == 'default'"
            @click="newHistogram">Submit</button>
        </div>
    </div>
    <div class="plot-item" v-if="plot_type == 'correlation' || plot_type == 'qcplot_src' || plot_type == 'qcplot_met' || plot_type == 'bruker'">
        <img :id="plot_id" :src="image_url">
    </div>
</template>

<script setup lang="ts">
import { onMounted, ref, watch, computed } from 'vue';
import { retrievePlot, type NormalConcentration, type MetaboliteFilterRule, type NormalConcentrationCollection } from '@/modules/query_module';
import { useQueryStore, type ArbitraryObject } from '@/stores/query';
import { getNconcs } from '@/modules/query_module';

const query = useQueryStore();

const emit = defineEmits<{
    'new-scatterplot': [m1: string, m2: string, phenotype: string|undefined, vis: MetaboliteFilterRule[]|undefined, units: ArbitraryObject|undefined];
    'new-histogram': [m: string, phenotype: string|undefined, vis: MetaboliteFilterRule[]|undefined,
     units: ArbitraryObject|undefined, histstyle: string|undefined, bins: number|undefined];
}>();


/**
 * Has one prop:
 * @param plot_id - The ID of the plot this item represents
 */
const props = defineProps({
    plot_id: String,
    plot_type: String,
})

onMounted(async () => {
    await retrieveImageUrl();
})

const newScatterplot = () => {
    emit('new-scatterplot', scatter_metabolite_1.value,  scatter_metabolite_2.value,
      scatter_phenotype.value != "default" ? scatter_phenotype.value : undefined, collectScatterRanges(), collectScatterUnits());
}

const newHistogram = () => {
    // TODO nconc missing here
    emit('new-histogram', hist_metabolite.value, hist_phenotype.value != "default" ? hist_phenotype.value : undefined,
     collectHistoRange(), collectHistoUnit(), hist_style.value, hist_bins.value);
}

const retrieveImageUrl = async () => {
    if (!props?.plot_id) return;
    image_url.value = await retrievePlot(props?.plot_id).then(
        (response) => {
            return (typeof response === "string" ? <string>response : "failed");
        }
    );
}

const getNconcsForMetabolite = async (compound: string) => {
    nconcs.value[compound] = await getNconcs(compound);
}

const collectScatterUnits = (): ArbitraryObject => {
    let res_obj = {} as ArbitraryObject;
    res_obj[scatter_metabolite_1.value] = query.unitForMetabolite(scatter_metabolite_1.value)[0];
    res_obj[scatter_metabolite_2.value] = query.unitForMetabolite(scatter_metabolite_2.value)[0];
    return res_obj;
}

const collectHistoUnit = () => {
    let res_obj = {} as ArbitraryObject;
    res_obj[hist_metabolite.value] = query.unitForMetabolite(hist_metabolite.value)[0];
    return res_obj;
}

const collectScatterRanges = (): MetaboliteFilterRule[] => {
    let ranges = [];
    const rs1 = rangeStringToFilterRule(scatter_vis_string_1.value, scatter_metabolite_1.value, "scatter1");
    const rs2 = rangeStringToFilterRule(scatter_vis_string_2.value, scatter_metabolite_2.value, "scatter2");
    rs1 && ranges.push(rs1);
    rs2 && ranges.push(rs2);
    return ranges;
}

const collectHistoRange = (): MetaboliteFilterRule[] => {
    const rs = rangeStringToFilterRule(hist_vis_string.value, hist_metabolite.value, "histogram");
    if (rs) return [rs];
    return [];
}

const rangeStringToFilterRule = (rs: string|NormalConcentration, metabolite: string, position: string): MetaboliteFilterRule | undefined => {

    let min: number = 0.0;
    let max: number|undefined;
    switch (rs) {
        case "default": //No vis. range chosen
            return undefined;
        case "vis": // Defined in query screen
            let query_filter_rule = query.query_filters?.filter((f) => f.filter_type == "vis")[0];
            if (query_filter_rule && query_filter_rule.min) min = query_filter_rule.min;
            if (query_filter_rule && query_filter_rule.max) max = query_filter_rule.max;
            break;
        case "custom": //Custom range
            switch (position) {
                case "scatter1":
                    if (scatter_vis1_custom_min.value) min = scatter_vis1_custom_min.value;
                    if (scatter_vis1_custom_max.value && scatter_vis1_custom_max.value > min) max = scatter_vis1_custom_max.value;
                    break;
                case "scatter2":
                    if (scatter_vis2_custom_min.value) min = scatter_vis2_custom_min.value;
                    if (scatter_vis2_custom_max.value && scatter_vis2_custom_max.value > min) max = scatter_vis2_custom_max.value;
                    break;
                case "histogram":
                    if (hist_vis_custom_min.value) min = hist_vis_custom_min.value;
                    if (hist_vis_custom_max.value && hist_vis_custom_max.value > min) max = hist_vis_custom_max.value;
                    break;
            }
            break;
        default:
            switch (position) {
                case "scatter1":
                    min = (scatter_vis_string_1.value as NormalConcentration).nconc_min;
                    max = (scatter_vis_string_1.value as NormalConcentration).nconc_max;
                    break;
                case "scatter2":
                    min = (scatter_vis_string_2.value as NormalConcentration).nconc_min;
                    max = (scatter_vis_string_2.value as NormalConcentration).nconc_max;
                    break;
                case "histogram":
                    min = (hist_vis_string.value as NormalConcentration).nconc_min;
                    max = (hist_vis_string.value as NormalConcentration).nconc_max;
                    break;
            }
            break;
    }

    let filter_rule: MetaboliteFilterRule = {
        compound_id: metabolite,
        filter_type: "vis",
        unit: "disregard", //set through emit
        min: Number(min),
    };
    if (max) filter_rule.max = Number(max);
    return filter_rule;
}

const image_url = ref<string|undefined>("");

const scatter_phenotype = ref<string>("default");
const scatter_metabolite_1 = ref<string>("default");
const scatter_metabolite_2 = ref<string>("default");
const scatter_vis_string_1 = ref<string|NormalConcentration>("default");
const scatter_vis_string_2 = ref<string|NormalConcentration>("default");
const scatter_vis1_custom_min = ref<number>(0.0);
const scatter_vis1_custom_max = ref<number|undefined>();
const scatter_vis2_custom_min = ref<number>(0.0);
const scatter_vis2_custom_max = ref<number|undefined>();

const nconcs = ref<NormalConcentrationCollection>({});

const hist_phenotype = ref<string>("default");
const hist_metabolite = ref<string>("default");
const hist_vis_string = ref<string|NormalConcentration>("default");
const hist_style = ref<string>("step|fill");
const hist_bins = ref<number>(30);
const hist_vis_custom_min = ref<number>(0.0);
const hist_vis_custom_max = ref<number|undefined>();

const applicable_phenotypes = computed(() => {
    if (!query.query_phenotypes) return [];
    let result_list: string[] = []
    for (let phenotype of Object.keys(query.query_phenotypes)) {
        let delete_p = false;
        for (let filter_rule of query.query_phenotype_filters) {
            if (phenotype == filter_rule.phenotype && !filter_rule.include) delete_p = true;
        } 
        if (!delete_p)
            result_list.push(phenotype);
    }
    return result_list;
});

watch(() => props?.plot_id, async() => {
    await retrieveImageUrl();
});

/*watch(() => scatter_metabolite_1.value, () => {
    let new_nconc = await getNconcs(scatter_metabolite_1.value);
    if (new_nconc)
        scatter_nconcs.value?[scatter_metabolite_1.value] = new_nconc;
});*/

</script>

<style scoped>

.range {
    display: flex;
    padding: 0.5rem;
    gap: 1rem;
}

.range > input {
    max-width: 30%;
}

.plot-item-with-controls {
    background-color: var(--color-bg);
    display: grid;
    grid-auto-flow: column;
    grid-template-columns: 1fr 300px;
    column-gap: 1rem;
}

.plot-item {
    background-color: var(--color-bg);
    display: grid;
    grid-auto-flow: column;
    grid-template-columns: 1fr;
}

.plot-controls {
    font-size: var(--fs-small);
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    justify-content: top;
    margin-top: 4rem;
}

select {
    margin-bottom: 1rem;
    width: 100%;
}

</style>
